/*
    NullBot Robot Platform - Server - 2005-2011 Jason Hunt
    
    GNU GENERAL PUBLIC LICENSE Version 2, June 1991
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
    File: server.c
*/


#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>

#include "../version.h"
#include "../netcomm.h"

#include "utility.h"
#include "config.h"
#include "server.h"
#include "camera.h"
#include "robot.h"

#define MODULE_NAME "[Server] "


int program_done = 0;
          
camera_type camera[MAX_CAMERA];
int num_cameras = 0;          
          

/* Hangle signals */
void sighandler(int sig)
{
    alert(MODULE_NAME "Program shutdown\n");
    program_done = 1;
}
/* End of sighandler */


/* Main */
int main ( int argc, char *argv[] ) 
{
    alert(MODULE_NAME "Robot Server %s V %s\n", COPYRIGHT, VERSION);

    signal(SIGABRT, &sighandler);
	signal(SIGTERM, &sighandler);
	signal(SIGINT, &sighandler);

    load_config("nullbot.conf");
    
    robot_start();
    
    // Main loop
    while(!program_done) sleep(1);

    robot_stop();
    
    int i;
    
    for (i = 0; i < num_cameras; i++)
        camera_stop(&camera[i]);
    
    // Wait for threads    
    sleep(2);
    
    return 0;
}
/* End of main */












