/*
	NullBot Robot Platform - NodeIO - 2005-2011 Jason Hunt

	Contact: nulluser@gmail.com
    
	GNU GENERAL PUBLIC LICENSE Version 2, June 1991
	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	File: i2c.h
*/


#ifndef I2C1_H
#define I2C1_H


#define I2C_TIMEOUT 50

#define I2C_SUCCESS 0
#define I2C_FAIL 1

#define I2C_READ	1	// I2C Read address modifier
#define I2C_WRITE	0	// I2C Write address modifier


int i2c_start(unsigned char address);
void i2c_restart( void );
void i2c_stop();
unsigned char i2c_read( void);
void i2c_ack ( void );
void i2c_nack ( void );
unsigned char i2c_readbytes(unsigned char *data, unsigned int len);
void i2c_write( unsigned char v);
unsigned char i2c_write_reg(unsigned char address, unsigned char reg, unsigned char value);
void i2c_init( void );

#endif

