/*
    NullBot Robot Client 

    (C) 2005-2011 Jason Hunt

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com

    FILE: netcomm.h
*/


#ifndef NETCOMM_H
#define NETCOMM_H

#define NC_IMAGE_SIZE   0x40
#define NC_IMAGE_SIZE_LEN 11

#define CONTROL_KEEP_ALIVE      0x00
#define CONTROL_SHUTDOWN        0x02
#define CONTROL_VERSION         0x10
#define CONTROL_STRING          0x20
#define CONTROL_UPDATE          0x30
#define CONTROL_FIREON          0x40
#define CONTROL_FIREOFF         0x41



#define FAULT_UT	0x01   // update timeout
#define FAULT_PT	0x02   // packet timeout
#define FAULT_CF	0x04   // checksum fail
#define FAULT_IP	0x08   // invalid packet
#define FAULT_IL	0x10   // invalid length
#define FAULT_OE	0x20   // invalid packet
#define FAULT_FE	0x40   // invalid length
#define FAULT_OK	0x80   // invalid length




// General packet format
// This format is used for both serial and network communications

// [total size][packet type][data] ... [checksum]
// All items are bytes
// Max packet length is 252 bytes

// The lenghts below do not include the size, checksum, or packettype.
// The lenghts is for the data section only




// Node to Client
#define COMM_NC_TEL         0x20		// Io to Node telemetry Packet




// CLient to node

#define COMM_CN_CTRL         0x30		// Io to Node telemetry Packet

// This copies all of the raw telemetry from the NodeIO and adds more

/*
	tel_packet[2] = rate_z_diff;;
	tel_packet[3] = rate_z_diff >> 8;

	tel_packet[4] = rate_z_offset;
	tel_packet[5] = rate_z_offset >> 8;

	tel_packet[6] = analog[1];
	tel_packet[7] = analog[1]>>8;

	tel_packet[8] = (angle_z) >> 8;
	tel_packet[9] = (angle_z >> 8) >> 8; 

	tel_packet[10] = vel_x;
	tel_packet[11] = vel_x >> 8;

	tel_packet[12] = vel_y;
	tel_packet[13] = vel_y >> 8;

//	tel_packet[14] = sample_time;
//	tel_packet[15] = sample_time >> 8;

	tel_packet[14] = sample_rate;
	tel_packet[15] = sample_rate >> 8;
	
*/

/*
    buffer[ data_size++] = robot.wifi_link;
    buffer[ data_size++] = 1;
    buffer[ data_size++] = 2;
    buffer[ data_size++] = 3;
    
  */  


// Node to NodeIO Messages

#define COMM_NI_CTRL		0x40		// Node to IO control Packet
#define COMM_NI_CTRL_LEN    4
/*

	// EXtract the control data
	servo_pos[0] = buff[0];
	servo_pos[1] = buff[1];
	servo_pos[2] = buff[2];
	servo_pos[3] = buff[3];
	
	
*/




// Node IO to Node Messages
#define COMM_IN_TEL         0x50		// Io to Node telemetry Packet
//#define COMM_IN_TEL_LEN     20          	

/*
	tel_packet[2] = rate_z_diff;;
	tel_packet[3] = rate_z_diff >> 8;

	tel_packet[4] = rate_z_offset;
	tel_packet[5] = rate_z_offset >> 8;

	tel_packet[6] = analog[1];
	tel_packet[7] = analog[1]>>8;

	tel_packet[8] = (angle_z) >> 8;
	tel_packet[9] = (angle_z >> 8) >> 8; 

	tel_packet[10] = vel_x;
	tel_packet[11] = vel_x >> 8;

	tel_packet[12] = vel_y;
	tel_packet[13] = vel_y >> 8;

//	tel_packet[14] = sample_time;
//	tel_packet[15] = sample_time >> 8;

	tel_packet[14] = sample_rate;
	tel_packet[15] = sample_rate >> 8;
	
*/


#endif


















